Merge pull request #75 from framps/debug

Add debug infrastructure for debug statements
This commit is contained in:
Drew Bonasera 2019-07-29 19:44:11 -04:00 committed by GitHub
commit cbd4720ea9
No known key found for this signature in database
GPG Key ID: 4AEE18F83AFDEB23
1 changed files with 110 additions and 23 deletions

View File

@ -1,24 +1,69 @@
#!/bin/bash
version="v0.1"
function info() {
echo "$1..."
}
function error() {
echo -n "ERROR occured in line $1: "
shift
echo "$@"
}
function cleanup() {
if losetup $loopback &>/dev/null; then
losetup -d "$loopback"
fi
if [ "$debug" = true ]; then
local old_owner=$(stat -c %u:%g "$src")
chown $old_owner "$LOGFILE"
fi
}
usage() { echo "Usage: $0 [-s] imagefile.img [newimagefile.img]"; exit -1; }
function logVariables() {
if [ "$debug" = true ]; then
echo "Line $1" >> "$LOGFILE"
shift
local v var
for var in "$@"; do
eval "v=\$$var"
echo "$var: $v" >> $LOGFILE
done
fi
}
usage() { echo "Usage: $0 [-sd] imagefile.img [newimagefile.img]"; exit -1; }
should_skip_autoexpand=false
debug=false
while getopts ":s" opt; do
while getopts ":sd" opt; do
case "${opt}" in
s) should_skip_autoexpand=true ;;
d) debug=true;;
*) usage ;;
esac
done
shift $((OPTIND-1))
CURRENT_DIR=$(pwd)
SCRIPTNAME="${0##*/}"
LOGFILE=${CURRENT_DIR}/${SCRIPTNAME%.*}.log
if [ "$debug" = true ]; then
info "Creating log file $LOGFILE"
rm $LOGFILE &>/dev/null
exec 1> >(stdbuf -i0 -o0 -e0 tee -a "$LOGFILE" >&1)
exec 2> >(stdbuf -i0 -o0 -e0 tee -a "$LOGFILE" >&2)
fi
echo "${0##*/} $version"
#Args
src="$1"
img="$1"
#Usage checks
@ -26,11 +71,11 @@ if [[ -z "$img" ]]; then
usage
fi
if [[ ! -f "$img" ]]; then
echo "ERROR: $img is not a file..."
error $LINENO "$img is not a file..."
exit -2
fi
if (( EUID != 0 )); then
echo "ERROR: You need to be running as root."
error $LINENO "You need to be running as root."
exit -3
fi
@ -38,17 +83,17 @@ fi
for command in parted losetup tune2fs md5sum e2fsck resize2fs; do
which $command 2>&1 >/dev/null
if (( $? != 0 )); then
echo "ERROR: $command is not installed."
error $LINENO "$command is not installed."
exit -4
fi
done
#Copy to new file if requested
if [ -n "$2" ]; then
echo "Copying $1 to $2..."
info "Copying $1 to $2..."
cp --reflink=auto --sparse=always "$1" "$2"
if (( $? != 0 )); then
echo "ERROR: Could not copy file..."
error $LINENO "Could not copy file..."
exit -5
fi
old_owner=$(stat -c %u:%g "$1")
@ -60,6 +105,7 @@ fi
trap cleanup ERR EXIT
#Gather info
info "Gatherin data"
beforesize=$(ls -lh "$img" | cut -d ' ' -f 5)
parted_output=$(parted -ms "$img" unit B print | tail -n 1)
partnum=$(echo "$parted_output" | cut -d ':' -f 1)
@ -69,6 +115,8 @@ tune2fs_output=$(tune2fs -l "$loopback")
currentsize=$(echo "$tune2fs_output" | grep '^Block count:' | tr -d ' ' | cut -d ':' -f 2)
blocksize=$(echo "$tune2fs_output" | grep '^Block size:' | tr -d ' ' | cut -d ':' -f 2)
logVariables $LINENO tune2fs_output currentsize blocksize
#Check if we should make pi expand rootfs on next boot
if [ "$should_skip_autoexpand" = false ]; then
#Make pi expand rootfs on next boot
@ -146,43 +194,82 @@ else
fi
#Make sure filesystem is ok
e2fsck -p -f "$loopback"
minsize=$(resize2fs -P "$loopback" | cut -d ':' -f 2 | tr -d ' ')
info "Checking filesystem"
if ! e2fsck -p -f "$loopback"; then
rc=$?
error $LINENO "fsck failed with rc $rc"
exit -9
fi
if ! minsize=$(resize2fs -P "$loopback"); then
rc=$?
error $LINENO "resize2fs failed with rc $rc"
exit -10
fi
minsize=$(cut -d ':' -f 2 <<< $minsize | tr -d ' ')
logVariables $LINENO minsize
if [[ $currentsize -eq $minsize ]]; then
echo "ERROR: Image already shrunk to smallest size"
exit -6
error $LINENO "Image already shrunk to smallest size"
exit -11
fi
#Add some free space to the end of the filesystem
extra_space=$(($currentsize - $minsize))
logVariables $LINENO extra_space
for space in 5000 1000 100; do
if [[ $extra_space -gt $space ]]; then
minsize=$(($minsize + $space))
break
fi
done
logVariables $LINENO minsize
#Shrink filesystem
info "Shrinking filesystem"
resize2fs -p "$loopback" $minsize
if [[ $? != 0 ]]; then
echo "ERROR: resize2fs failed..."
error $LINENO "resize2fs failed"
mount "$loopback" "$mountdir"
mv "$mountdir/etc/rc.local.bak" "$mountdir/etc/rc.local"
umount "$mountdir"
losetup -d "$loopback"
exit -7
exit -12
fi
sleep 1
#Shrink partition
partnewsize=$(($minsize * $blocksize))
newpartend=$(($partstart + $partnewsize))
parted -s -a minimal "$img" rm $partnum >/dev/null
parted -s "$img" unit B mkpart primary $partstart $newpartend >/dev/null
logVariables $LINENO partnewsize newpartend
if ! parted -s -a minimal "$img" rm $partnum; then
rc=$?
error $LINENO "parted failed with rc $rc"
exit -13
fi
if ! parted -s "$img" unit B mkpart primary $partstart $newpartend; then
rc=$?
error $LINENO "parted failed with rc $rc"
exit -14
fi
#Truncate the file
endresult=$(parted -ms "$img" unit B print free | tail -1 | cut -d ':' -f 2 | tr -d 'B')
truncate -s $endresult "$img"
aftersize=$(ls -lh "$img" | cut -d ' ' -f 5)
info "Shrinking image"
if ! endresult=$(parted -ms "$img" unit B print free); then
rc=$?
error $LINENO "parted failed with rc $rc"
exit -15
fi
echo "Shrunk $img from $beforesize to $aftersize"
endresult=$(tail -1 <<< $endresult | cut -d ':' -f 2 | tr -d 'B')
logVariables $LINENO endresult
if ! truncate -s $endresult "$img"; then
rc=$?
error $LINENO "trunate failed with rc $rc"
exit -16
fi
aftersize=$(ls -lh "$img" | cut -d ' ' -f 5)
logVariables $LINENO aftersize
info "Shrunk $img from $beforesize to $aftersize"